<?php $__env->startSection('title'); ?>
Dashboard - Kategori Soal
<?php $__env->stopSection(); ?>

<?php $__env->startSection('style'); ?>
<link rel="stylesheet" href="../../assets/css/custom.css" type="text/css">
<link rel="stylesheet" href="../../assets/css/theme-sugar.css" type="text/css">
<link rel="stylesheet" href="../../assets/css/element-ui/index.css" type="text/css">
<link rel="stylesheet" href="../../assets/vendor/vue-select/vue-select.css" type="text/css">

<style>
    .page-item .page-link {
        width: 2rem;
        height: 2rem;

        font-size: 0.75rem;
    }

    .overlay-container {
        position: relative;
    }

    .overlay-image {
        opacity: 1;
        display: block;

        transition: .5s ease;
        backface-visibility: hidden;
    }

    .overlay-middle {
        transition: .5s ease;
        opacity: 0;
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        -ms-transform: translate(-50%, -50%);
        text-align: center;
    }

    .overlay-container:hover .overlay-image {
        opacity: 0.3;
    }

    .overlay-container:hover .overlay-middle {
        opacity: 1;
    }

    .overlay-text {
        background-color: #4CAF50;
        color: white;
        font-size: 16px;
        padding: 16px 32px;
    }
</style>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('search-box'); ?>
<div class="navbar-search navbar-search-light form-inline mr-sm-3" id="navbar-search-main">
    <div class="form-group mb-0" :class="{'focused':table.filters[0].value||table.filters[0].focus}">
        <div class="input-group input-group-alternative input-group-merge">
            <div class="input-group-prepend">
                <span class="input-group-text"><i class="fas fa-search"></i></span>
            </div>
            <input @blur.self="table.filters[0].focus = false" @click="table.filters[0].focus=true" v-model.trim="table.filters[0].value" class="form-control" placeholder="Cari" type="text">

            <div v-if="table.filters[0].value" class="input-group-append mr-2 d-none d-md-flex" @click="table.filters[0].value =  ''">
                <button class="input-group-text"><i class="fas fa-backspace"></i></button>
            </div>

            <div class="input-group-append d-md-none d-flex">
                <button v-if="table.filters[0].value" @click="table.filters[0].value =  ''" class="input-group-text pr-0 pl-2"><i class="fas fa-backspace"></i></button>

                <button data-action="search-close" class="mr-2 input-group-text"><i class="fas fa-times"></i></button>
            </div>
        </div>
    </div>

</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('mobile-search'); ?>
<?php echo $__env->make('dashboard.components.mobile-search', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('page-title'); ?>
<h6 class="h2 text-white d-inline-block mb-0">
    Kategori Soal
</h6>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('breadcrumb'); ?>
<li class="breadcrumb-item text-white">
    <i class="fas fa-list"></i>
</li>
<li class="breadcrumb-item text-white">Manajemen Kategori Soal</li>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('action-bar'); ?>

<div class="mt-3 d-sm-none"></div>

<div v-if="isLoaded && !isFailed" class="d-flex justify-content-end d-none" :class="{'d-block':isLoaded && !isFailed}">

    <button @click="showModalTambah" class="m-1 btn btn-sm btn-neutral">Tambah</button>

</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('content'); ?>
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed" :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="text-primary">List Kategori Soal</h3>
                    </div>
                    <div class="card-body">
                        <data-tables ref="dt" style="width: 100%" :page-size.sync="table.pagination.perPage" :current-page.sync="table.pagination.current" @current-page-change="handleCurrentPageChange" :filters="table.filters" :table-props="table.props" :data="kategoriSoals" :pagination-props="table.pagination">

                            <el-table-column label="Kode" min-width="50" prop="kode">
                                <template slot-scope="scope">
                                    <span>
                                        {{ scope . row . kode }}
                                    </span>
                                </template>
                            </el-table-column>

                            <el-table-column label="Nama" min-width="200" prop="nama" sortable="true">
                                <template slot-scope="scope">
                                    <span>
                                        {{ scope . row . nama . toUpperCase() }}
                                    </span>
                                </template>
                            </el-table-column>

                            <el-table-column label="Jenis" min-width="50" prop="jenis_ujian" sortable="true">
                                <template slot-scope="scope">
                                    <span>
                                        {{ scope . row . jenis_ujian . toUpperCase() }}
                                    </span>
                                </template>
                            </el-table-column>

                            <el-table-column label="PG" min-width="50" prop="pg" sortable="true">
                                <template slot-scope="scope">
                                    <span>
                                        {{ scope . row . pg}}
                                    </span>
                                </template>
                            </el-table-column>


                            <el-table-column label="Actions" min-width="100" align="center">
                                <template slot-scope="scope">
                                    <el-tooltip class="item" effect="dark" content="Hapus" placement="top">
                                        <button @click="confirmDelete(scope.row)" type="button" class="mr-0 mt-1 btn btn-outline-danger btn-sm btn-icon-only">
                                            <span class="btn-inner--icon"><i class="fas fa-trash"></i></span>
                                        </button>
                                    </el-tooltip>

                                    <el-tooltip class="item" effect="dark" content="Edit" placement="top">
                                        <button @click="editKategoriSoal(scope.row)" type="button" class="mr-0 mt-1 btn btn-outline-primary btn-sm btn-icon-only">
                                            <span class="btn-inner--icon"><i class="fas fa-pencil-alt"></i></span>
                                        </button>
                                    </el-tooltip>

                                </template>
                            </el-table-column>

                        </data-tables>
                    </div>

                    <div class="card-footer d-flex  justify-content-around align-items-end pt-2">

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="perpage">Item/Halaman</label>

                            <select id="perpage" v-model="table.pagination.perPage" class="form-control form-control-sm" id="inlineFormCustomSelect">
                                <option v-for="item in pageSizes.length" :key="item" :value="pageSizes[item-1]">
                                    {{ pageSizes[item - 1] + '/page' }}</option>
                            </select>
                        </div>

                        <div class="col-md-8 col-sm-12 d-flex flex-column justify-content-center text-center">
                            <h5>Jumlah data: {{ table.itemSize }}</h5>
                            <paginate :value="table.pagination.current" :page-count="numberPages" :page-range="3" :click-handler="clickCallback" :prev-text="''" :next-text="''" :container-class="'pagination justify-content-center mb-0'" :page-class="'page-item'" :page-link-class="'page-link btn-sm'" :prev-class="'page-item'" :prev-link-class="'fas fa-angle-left page-link'" :next-class="'page-item'" :next-link-class="'fas fa-angle-right page-link'" :hide-prev-next="false" :break-view-text="''" :break-view-link-class="'fas fa-ellipsis-h'">
                            </paginate>
                        </div>

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="to-page">Ke Halaman</label>
                            <input type="number" min="1" max="numberPage" v-model.number="table.pagination.current" id="to-page" class="form-control form-control-sm">
                        </div>

                    </div>
                </div>
            </div>

        </div>

        <confirm-delete v-if="form.delete.confirm" :show-modal="form.delete.confirm" :is-deleting="form.delete.isDeleting" @onclose="closeConfirmDelete" @onconfirm="hapusKategoriSoal">
        </confirm-delete>

        <div v-if="form.tambah.show" class="d-none" :class="{'d-block':form.tambah.show}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-dialog-centered " role="document">
                    <div class="modal-content">
                        <div v-if="!form.isSubmitting" class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle">
                                    {{(!form.isEditing)?'Tambah':'Edit'}}

                                </span>
                            </h5>
                            <button type="button" class="close" @click="closeModalTambah">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0" style="max-height: 30rem; overflow-y: auto;">
                            <div v-if="form.isSubmitting">
                                <div class="spinner">
                                    <div class="rect1 bg-primary"></div>
                                    <div class="rect2 bg-primary"></div>
                                    <div class="rect3 bg-primary"></div>
                                    <div class="rect4 bg-primary"></div>
                                    <div class="rect5 bg-primary"></div>
                                </div>
                                <h3 class="mt-4 mb-5 text-primary text-center">
                                    Sedang menyimpan data..
                                </h3>
                            </div>
                            <div v-if="!form.isSubmitting">

                                <div class="row">
                                    <div class="col-md-9">
                                        <div class="form-group">
                                            <div class="form-group">
                                                <label class="form-control-label" for="nama">Nama</label>
                                                <input id="nama" v-model.trim="form.data.nama" class="form-control" placeholder="Masukkan nama" type="text" required>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <div class="form-group">
                                                <label class="form-control-label" for="kode">Kode</label>
                                                <input id="kode" v-model.trim="form.data.kode" class="form-control" placeholder="Kode" type="text" required>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <div class="form-group">
                                                <label class="form-control-label" for="jenis_ujian">Jenis Ujian</label>
                                                <select v-model="form.data.jenis_ujian" class="form-control" id="jenis_ujian">
                                                    <option value="skb">SKB</option>
                                                    <option value="skd">SKD</option>
                                                  </select>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <div class="form-group">
                                                <label class="form-control-label" for="pg">PG</label>
                                                <input id="pg" v-model.number="form.data.pg" class="form-control" placeholder="Passing Grades" type="number" min="0" max="1000" required>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div v-if="!form.isSubmitting" class="modal-footer p-3">
                            <button @click="handleReset(form.isEditing)" class="btn btn-secondary">Reset</button>

                            <button @click="handleSubmit(form.isEditing)" class="btn btn-primary" :disabled="!cekFormTambah">
                                {{(form.isEditing)?'Update':'Tambah'}}
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('script'); ?>
<script src="<?php echo e(asset('assets/js/element-ui/index.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/locales/en.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/data-tables.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-paginate.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-toast-notification.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue/confirm-delete.js')); ?>"></script>

<script>
    let base = "<?php echo e(url('/api')); ?>"
    let kategoriSoalUrl = base + "/kategori/soal"

    ELEMENT.locale(ELEMENT.lang.en)
    Vue.use(VueToast);
    Vue.use(DataTables.DataTables)

    Vue.component('paginate', VuejsPaginate)

    var app = new Vue({
        el: '#panel',
        data: {
            table: {
                itemSize: 0,
                filters: [{
                    prop: ['kode', 'nama', 'jenis_ujian', 'pg'],
                    value: '',
                    focus: false
                }],
                pagination: {
                    pageSizes: [10, 30, 50],
                    current: 1,
                    perPage: 10
                }
            },
            form: {
                data: {
                    nama: '',
                    kode: '',
                    jenis_ujian: '',
                    pg: '',
                    show: true,
                },
                tambah: {
                    show: false
                },
                isSubmitting: false,
                isEditing: false,
                update: {
                    show: false,
                    index: '',
                    old: {}
                },
                delete: {
                    confirm: false,
                    isDeleting: false,
                    data: {}
                }
            },
            isFailed: false,
            isLoaded: false,
            carousels: [],
            kategoriSoals: [],
        },
        methods: {
            openFile() {
                this.$refs.file.click()
            },
            onFileChange(e) {
                const image = e.target.files[0];
                const reader = new FileReader();
                reader.readAsDataURL(image);
                reader.onload = e => {
                    this.form.data.img = e.target.result;
                };
            },
            clickCallback(page) {
                this.table.pagination.current = page
            },
            handleCurrentPageChange(page) {
                this.table.pagination.current = page
            },
            showModalTambah() {
                this.form.tambah.show = true
            },
            closeModalTambah() {
                this.resetFormTambah()
                this.form.isSubmitting = false
                this.form.isEditing = false
                this.form.isDeleting = false
                this.form.tambah.show = false
            },
            handleReset(isEditing) {
                if (isEditing) {
                    this.resetFormUpdate()
                } else {
                    this.resetFormTambah()
                }
            },
            handleSubmit(isEditing) {
                if (!isEditing) {
                    this.insertKategoriSoal()
                } else {
                    this.updateKategoriSoal()
                }
            },
            resetFormTambah() {
                const data = {
                    nama: '',
                    kode: '',
                    jenis_ujian: '',
                    pg: '',
                    show: true,
                }
                // this.$refs.file.value = null
                Vue.set(this.form, 'data', data)
                this.form.isSubmitting = false
            },
            resetFormUpdate() {
                const old = this.form.update.old

                const data = {
                    nama: old.nama,
                    kode: old.kode,
                    jenis_ujian: old.jenis_ujian,
                    pg: old.pg,
                    show: old.show,
                }

                Vue.set(this.form, 'data', data)
                this.form.isSubmitting = false
            },
            showToast(msg, type) {
                Vue.$toast.open({
                    message: msg,
                    type: type,
                    // all of other options may go here
                });
            },
            async insertKategoriSoal() {
                let form = this.form.data
                this.form.isSubmitting = true
                await axios
                    .post(kategoriSoalUrl, form)
                    .then((response) => {
                        
                        console.log(response.data);

                        this.kategoriSoals.push(response.data.data)

                        this.resetFormTambah()
                        this.showToast(
                            "Berhasil disimpan.", 'info'
                        )

                    }, (error) => {
                        this.form.isSubmitting = false
                        this.showToast('Gagal disimpan.', 'error')

                    })

            },
            editKategoriSoal(row) {
                this.form.isEditing = true
                const update = this.form.update
                let index = this.kategoriSoals.indexOf(row)

                update.index = index
                Vue.set(update, 'old', JSON.parse(JSON.stringify(this.kategoriSoals[index])))
                Vue.set(this.form, 'data', JSON.parse(JSON.stringify(this.kategoriSoals[index])))

                this.form.tambah.show = true
            },
            async updateKategoriSoal() {
                this.form.isSubmitting = true
                let form = this.form.data
                const id_to = this.form.update.old.id
                let id = this.kategoriSoals.findIndex(function(to) {
                    return to.id == id_to
                })

                await axios
                    .put(kategoriSoalUrl, form)
                    .then((response) => {

                        Vue.set(this.kategoriSoals, id, response.data.data)

                        this.showToast(
                            `Berhasil update`, 'info'
                        )

                        this.form.isSubmitting = false
                        this.closeModalTambah()

                    }, (error) => {
                        this.showToast('Gagal update data', 'error')
                        this.form.isSubmitting = false
                        this.form.update.show = false
                    })
            },
            async toggleShow(row) {
                let form = this.form.data
                const id_to = this.form.update.old.id
                let id = this.kategoriSoals.findIndex(function(to) {
                    return to.id == id_to
                })

                let data = {
                    id: row.id,
                    show: !row.show
                }

                await axios
                    .put(kategoriSoalUrl, data)
                    .then((response) => {

                        Vue.set(this.kategoriSoals, id, response.data.data)

                        this.showToast(
                            `Berhasil update`, 'info'
                        )

                        this.form.isSubmitting = false

                    }, (error) => {
                        this.showToast('Gagal update data', 'error')
                        this.form.isSubmitting = false
                        this.form.update.show = false
                    })
            },
            cancelUpdate() {
                this.resetFormTambah()
                this.showToast('Batal edit data tryouts', 'default')

            },
            confirmDelete(row) {
                this.form.delete.data = row
                this.form.delete.confirm = true
            },
            closeConfirmDelete() {
                this.form.delete.data = {}
                this.form.delete.confirm = false
                this.form.delete.isDeleting = false
            },
            async hapusKategoriSoal() {
                this.form.delete.isDeleting = true

                let item = this.form.delete.data
                let id = this.kategoriSoals.indexOf(item)

                await axios
                    .delete(kategoriSoalUrl, {
                        data: {
                            id: item.id
                        }
                    })
                    .then((response) => {
                        this.kategoriSoals.splice(id, 1)

                        this.showToast(
                            `Berhasil menghapus Data`, 'info'
                        )

                        this.closeConfirmDelete()

                    }, (error) => {
                        this.showToast('Gagal menghapus data', 'error')

                        this.closeConfirmDelete()
                    })

            },
            async initialLoad() {
                await axios
                    .get(kategoriSoalUrl)
                    .then((response) => {
                        Vue.set(this, "kategoriSoals", response.data.data)
                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            }
        },
        computed: {
            cekFormTambah() {
                let tambah = this.form.data

                return (tambah.nama && tambah.kode)
            },
            numberPages() {
                return Math.ceil(this.table.itemSize / this.table.pagination.perPage)
            },
            pageSizes() {
                if (this.kategoriSoals.length > 100) {
                    return [
                        5, 10, 30, 50, 100
                    ]
                }

                return [
                    5, 10, 30, 50, this.kategoriSoals.length
                ]
            }
        },
        watch: {
            'table.pagination.current'(newVal) {
                if (!newVal || newVal == 0) {
                    this.table.pagination.current = 1
                }
                if (newVal > this.numberPages) {
                    this.table.pagination.current = this.numberPages
                }
            }
        },
        created() {
            this.initialLoad()

        },
        updated() {
            Vue.set(this.table, 'itemSize', this.$refs.dt.total)
            if (this.$refs.dt.$refs.elPagination) {
                this.$refs.dt.$refs.elPagination.$el.className = 'd-none'
            }
        },
    })
</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('dashboard.components.layout', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/dosp7473/public_html/cpns/dashboard/resources/views/dashboard/kategori-soal/index.blade.php ENDPATH**/ ?>