<?php $__env->startSection('title'); ?>
Dashboard
<?php $__env->stopSection(); ?>

<?php $__env->startSection('style'); ?>
<link rel="stylesheet" href="<?php echo e(asset('assets/css/custom.css')); ?>" type="text/css">
<link rel="stylesheet" href="<?php echo e(asset('assets/css/theme-sugar.css')); ?>" type="text/css">
<link rel="stylesheet" href="<?php echo e(asset('assets/css/element-ui/index.css')); ?>" type="text/css">
<link rel="stylesheet" href="<?php echo e(asset('assets/vendor/vue-select/vue-select.css')); ?>" type="text/css">


<style>
    .page-item .page-link {
        width: 2rem;
        height: 2rem;

        font-size: 0.75rem;
    }

    .overlay-container {
        position: relative;
    }

    .overlay-image {
        opacity: 1;
        display: block;

        transition: .5s ease;
        backface-visibility: hidden;
    }

    .overlay-middle {
        transition: .5s ease;
        opacity: 0;
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        -ms-transform: translate(-50%, -50%);
        text-align: center;
    }

    .overlay-container:hover .overlay-image {
        opacity: 0.3;
    }

    .overlay-container:hover .overlay-middle {
        opacity: 1;
    }

    .overlay-text {
        background-color: #4CAF50;
        color: white;
        font-size: 16px;
        padding: 16px 32px;
    }
</style>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('search-box'); ?>
<div class="navbar-search navbar-search-light form-inline mr-sm-3" id="navbar-search-main">
    <div class="form-group mb-0" :class="{'focused':table.filters[0].value||table.filters[0].focus}">
        <div class="input-group input-group-alternative input-group-merge">
            <div class="input-group-prepend">
                <span class="input-group-text"><i class="fas fa-search"></i></span>
            </div>
            <input @blur.self="table.filters[0].focus = false" @click="table.filters[0].focus=true" v-model.trim="table.filters[0].value" class="form-control" placeholder="Cari" type="text">

            <div v-if="table.filters[0].value" class="input-group-append mr-2 d-none d-md-flex" @click="table.filters[0].value =  ''">
                <button class="input-group-text"><i class="fas fa-backspace"></i></button>
            </div>

            <div class="input-group-append d-md-none d-flex">
                <button v-if="table.filters[0].value" @click="table.filters[0].value =  ''" class="input-group-text pr-0 pl-2"><i class="fas fa-backspace"></i></button>

                <button data-action="search-close" class="mr-2 input-group-text"><i class="fas fa-times"></i></button>
            </div>
        </div>
    </div>

</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('mobile-search'); ?>
<?php echo $__env->make('dashboard.components.mobile-search', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('page-title'); ?>
<h6 class="h2 text-white d-inline-block mb-0">
    {{(riwayat.tryout)?riwayat.tryout.nama.toUpperCase():''}}
</h6>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('breadcrumb'); ?>
<li class="breadcrumb-item text-white">
    <i class="fas fa-history"></i>
</li>
<li class="breadcrumb-item text-white"><?php echo e(ucfirst(Request::segment(1))); ?></li>
<li class="breadcrumb-item text-white">

    <?php echo e(ucfirst(Request::segment(2))); ?>

</li>
<li class="breadcrumb-item text-white">Riwayat</li>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('action-bar'); ?>
<div class="mt-3 d-sm-none"></div>
<div v-if="isLoaded && !isFailed" class="d-flex justify-content-end">
    <?php
    $start=url('/ujian/tryout').'/'.Request::segment(3);
    ?>

    <a href="<?php echo e($start.'/start'); ?>">
        <button class="m-1 btn btn-sm btn-neutral">Kerjakan Lagi</button>
    </a>
</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('content'); ?>
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed" :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <ul class="nav nav-pills mb-0 mt-4 mx-4" id="pills-tab" role="tablist">
                        <li class="nav-item">
                            <a class="nav-link active" id="pills-riwayat-tab" data-toggle="pill" href="#pills-riwayat" role="tab" aria-controls="pills-riwayat" aria-selected="true">Riwayat</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" id="pills-grafik-tab" data-toggle="pill" href="#pills-grafik" role="tab" aria-controls="pills-grafik" aria-selected="false">Grafik Perkembangan</a>
                        </li>
                    </ul>
                    <div class="tab-content" id="pills-tabContent">
                        <div class="tab-pane fade show active" id="pills-riwayat" role="tabpanel" aria-labelledby="pills-riwayat-tab">
                            <div class="card-body">
                                <data-tables ref="dt" style="width: 100%" :page-size.sync="table.pagination.perPage" :current-page.sync="table.pagination.current" @current-page-change="handleCurrentPageChange" :filters="table.filters" :table-props="table.props" :data="riwayat.ujian" :pagination-props="table.pagination">


                                    <el-table-column label="Mulai" min-width="120%" prop="start" sortable="true">
                                        <template slot-scope="scope">
                                            <div class="d-flex flex-column h2">
                                                <span class="badge badge-pill badge-primary">
                                                    <i class="fas fa-calendar-check">
                                                    </i>
                                                    <span>
                                                        {{ new Date(scope . row . start*1000).toLocaleDateString('id-ID')}}
                                                    </span>
                                                </span>

                                                <span class="mt-1 badge badge-pill badge-primary">
                                                    <i class="fas fa-clock">
                                                    </i>
                                                    <span>
                                                        {{ new Date(scope . row . start*1000).toLocaleTimeString('id-ID')}}
                                                    </span>
                                                </span>
                                            </div>
                                        </template>
                                    </el-table-column>

                                    <el-table-column label="Selesai" min-width="120%" prop="finished" sortable="true">
                                        <template slot-scope="scope">
                                            <div class="d-flex flex-column h2">
                                                <span class="badge badge-pill badge-success">
                                                    <i class="fas fa-calendar-check">
                                                    </i>
                                                    <span>
                                                        {{ new Date(scope . row . finished*1000).toLocaleDateString('id-ID')}}
                                                    </span>
                                                </span>

                                                <span class="mt-1 badge badge-pill badge-success">
                                                    <i class="fas fa-clock">
                                                    </i>
                                                    <span>
                                                        {{ new Date(scope . row . finished*1000).toLocaleTimeString('id-ID')}}
                                                    </span>
                                                </span>
                                            </div>
                                        </template>
                                    </el-table-column>

                                    <el-table-column label="TIU" min-width="100%" prop="tiu_nilai" sortable="true">
                                        <template slot-scope="scope">
                                            <span class="h4">
                                                {{scope.row.tiu_nilai}}
                                            </span>
                                        </template>
                                    </el-table-column>

                                    <el-table-column label="TKP" min-width="100%" prop="tkp_nilai" sortable="true">
                                        <template slot-scope="scope">
                                            <span class="h4">
                                                {{scope.row.tkp_nilai}}
                                            </span>
                                        </template>
                                    </el-table-column>

                                    <el-table-column label="TWK" min-width="100%" prop="twk_nilai" sortable="true">
                                        <template slot-scope="scope">
                                            <span class="h4">
                                                {{scope.row.twk_nilai}}
                                            </span>
                                        </template>
                                    </el-table-column>

                                    <el-table-column label="Total" min-width="100%" prop="total_nilai" sortable="true">
                                        <template slot-scope="scope">
                                            <span class="h4">
                                                {{scope.row.total_nilai}}
                                            </span>
                                        </template>
                                    </el-table-column>

                                    <el-table-column label="Durasi" min-width="100%" prop="total_waktu" sortable="true">
                                        <template slot-scope="scope">
                                            <h2>
                                                <span class="badge badge-pill badge-primary">
                                                    <i class="fas fa-stopwatch mr-1">
                                                    </i>
                                                    <span>
                                                        {{ scope . row . total_waktu }}
                                                    </span>
                                                </span>
                                                </span>
                                            </h2>

                                        </template>
                                    </el-table-column>

                                    <el-table-column label="Keterangan" min-width="120%" prop="lululs" sortable="true">
                                        <template slot-scope="scope">
                                            <div class="h1">
                                                <span class="badge badge-pill" :class="(scope.row.is_lulus)?'badge-primary':'badge-warning'">
                                                    <span>
                                                        {{scope.row.lulus}}
                                                    </span>
                                                </span>
                                            </div>
                                        </template>
                                    </el-table-column>

                                    <el-table-column label="Actions" min-width="100%">
                                        <template slot-scope="scope">
                                            <el-tooltip class="item" effect="dark" content="Lihat Hasil" placement="top">
                                                <a :href="'<?php echo e(Request::segment(0).'/ujian/tryout/'.Request::segment(3).'/'); ?>'+scope.row.sesi+'/hasil'">
                                                    <button type="button" class="mr-0 mt-1 btn btn-outline-success btn-sm btn-icon-only">
                                                        <span class="btn-inner--icon"><i class="fas fa-chart-pie"></i></span>
                                                    </button>
                                                </a>
                                            </el-tooltip>

                                            <el-tooltip class="item" effect="dark" placement="top">
                                                <div slot="content">

                                                    <span v-if="riwayat.tryout.end*1000 > Date.now()">
                                                        Review Jawaban bisa diakses pada:
                                                        <br>
                                                        {{ new Date(riwayat.tryout.end*1000).toLocaleDateString('id-ID')}} /
                                                        {{ new Date(riwayat.tryout.end*1000).toLocaleTimeString('id-ID')}}

                                                    </span>

                                                    <span v-else>Review Jawaban</span>

                                                </div>

                                                <a :href="(riwayat.tryout.end*1000 > Date.now())?'#':'<?php echo e(url('/ujian/tryout/'.Request::segment(3)).'/'); ?>'+scope.row.sesi+'/review'">
                                                    <button type=" button" class="mr-0 mt-1 btn btn-outline-primary btn-sm btn-icon-only">
                                                        <span class="btn-inner--icon"><i class="fas fa-eye"></i></span>
                                                    </button>
                                                </a>

                                            </el-tooltip>

                                        </template>
                                    </el-table-column> --}}

                                </data-tables>
                            </div>

                            <div class="card-footer d-flex  justify-content-around align-items-end pt-2">

                                <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                                    <label class="h5" for="perpage">Item/Halaman</label>

                                    <select id="perpage" v-model="table.pagination.perPage" class="form-control form-control-sm" id="inlineFormCustomSelect">
                                        <option v-for="item in pageSizes.length" :key="item" :value="pageSizes[item-1]">
                                            {{ pageSizes[item - 1] + '/page' }}</option>
                                    </select>
                                </div>

                                <div class="col-md-8 col-sm-12 d-flex flex-column justify-content-center text-center">
                                    <h5>Jumlah data: {{ table.itemSize }}</h5>
                                    <paginate :value="table.pagination.current" :page-count="numberPages" :page-range="3" :click-handler="clickCallback" :prev-text="''" :next-text="''" :container-class="'pagination justify-content-center mb-0'" :page-class="'page-item'" :page-link-class="'page-link btn-sm'" :prev-class="'page-item'" :prev-link-class="'fas fa-angle-left page-link'" :next-class="'page-item'" :next-link-class="'fas fa-angle-right page-link'" :hide-prev-next="false" :break-view-text="''" :break-view-link-class="'fas fa-ellipsis-h'">
                                    </paginate>
                                </div>

                                <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                                    <label class="h5" for="to-page">Ke Halaman</label>
                                    <input type="number" min="1" max="numberPage" v-model.number="table.pagination.current" id="to-page" class="form-control form-control-sm">
                                </div>

                            </div>
                        </div>
                        <div class="tab-pane fade" id="pills-grafik" role="tabpanel" aria-labelledby="pills-grafik-tab">
                            <div class="m-4">
                                <div class="dropdown">
                                    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdown-kelas-to" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        Grafik berdasarkan
                                    </button>
                                    <div class="dropdown-menu" aria-labelledby="dropdown-kelas-to">
                                        <button v-for="(v, i) in tipe.options" class="dropdown-item" :key="i" @click="tipe.selected = v">
                                            {{v.nama}}
                                        </button>
                                    </div>
                                </div>

                                <div id="chart">
                                    <apexchart type="line" height="350" :options="chart(tipe.selected).chartOptions" :series="chart(tipe.selected).series"></apexchart>
                                </div>

                            </div>
                        </div>

                    </div>

                </div>

            </div>

        </div>

    </div>
</div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('script'); ?>
<script src="<?php echo e(asset('assets/js/element-ui/index.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/locales/en.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/data-tables.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-paginate.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/apexcharts.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/vue-apexcharts.min.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/axios.js')); ?>"></script>

<script>
    const base = "<?php echo e(url('/')); ?>/api"
    const kode = "<?php echo e(Request::segment(3)); ?>"
    const riwayat = base + "/ujian/tryout/" + kode + "/riwayat"


    ELEMENT.locale(ELEMENT.lang.en)
    Vue.use(DataTables.DataTables)
    Vue.use(VueApexCharts)
    Vue.component('apexchart', VueApexCharts)
    Vue.component('paginate', VuejsPaginate)

    var app = new Vue({
        el: '#panel',
        data: {
            tipe: {
                selected: {
                    nama: "Total Nilai",
                    value: "total_nilai"
                },
                options: [{
                        nama: "Total Nilai",
                        value: "total_nilai"
                    },
                    {
                        nama: "TIU",
                        value: "tiu_nilai"
                    },
                    {
                        nama: "TKP",
                        value: "tkp_nilai"
                    },
                    {
                        nama: "TWK",
                        value: "twk_nilai"
                    },
                ]
            },
            table: {
                itemSize: 0,
                header: [],
                props: {

                },
                filters: [{
                    prop: ['start', 'finished', "tiu_nilai", "tkp_nilai", "twk_nilai", "total_waktu", "total_nilai", "lulus"],
                    value: '',
                    focus: false
                }],
                pagination: {
                    pageSizes: [10, 30, 50],
                    current: 1,
                    perPage: 10
                }
            },
            isFailed: false,
            isLoaded: false,
            riwayat: {
                ujian: [],
                tryout: {}
            }
        },
        methods: {
            convertMenit(secs) {
                const sec = Math.round(secs)
                const m = Math.floor(sec / 60)
                const s = sec - (m * 60)

                const str_m = m.toString()
                const str_s = s.toString()

                const menit = (str_m.length == 1) ? "0" + str_m : str_m
                const detik = (str_s.length == 1) ? "0" + str_s : str_s

                return menit + ':' + detik
            },
            clickCallback(page) {
                this.table.pagination.current = page
            },
            handleCurrentPageChange(page) {
                this.table.pagination.current = page
            },
            chart(tipe) {
                let data = {
                    series: [{
                        name: '',
                        data: this.riwayat.ujian.map((e, i) => {
                            return {
                                x: e.start * 1000,
                                y: e[tipe.value]
                            }
                        })
                    }],
                    chartOptions: {
                        chart: {
                            height: 400,
                            type: 'line',
                            zoom: {
                                type: 'x',
                                enabled: true,
                                autoScaleYaxis: true
                            },
                            toolbar: {
                                autoSelected: 'zoom'
                            }
                        },
                        dataLabels: {
                            enabled: false
                        },
                        stroke: {
                            curve: 'smooth'
                        },
                        markers: {
                            size: 4
                        },
                        title: {
                            text: 'Grafik perkembangan berdasarkan ' + tipe.nama,
                            align: 'left',
                            margin: 10,
                            offsetX: 0,
                            offsetY: 20,
                            floating: false,
                            style: {
                                fontSize: '0.8rem',
                            },
                        },
                        yaxis: {
                            title: {
                                text: "Nilai",
                            }
                        },

                        grid: {
                            row: {
                                colors: ['#f3f3f3', 'transparent'], // takes an array which will be repeated on columns
                                opacity: 0.5
                            },
                        },
                        xaxis: {
                            type: 'datetime',
                        },
                    }
                }
                return data
            },
            async initialLoad() {
                await axios
                    .get(riwayat)
                    .then((response) => {
                        Vue.set(this.riwayat, 'tryout', response.data.data.tryout)

                        Vue.set(this.riwayat, 'ujian', response.data.data.ujian.map(
                            (item, i) => {
                                return {
                                    start: item.start,
                                    end: item.end,
                                    finished: item.finished,
                                    total_nilai: item.hasil.total_nilai,
                                    tiu_nilai: item.hasil.tiu_nilai,
                                    tkp_nilai: item.hasil.tkp_nilai,
                                    twk_nilai: item.hasil.twk_nilai,
                                    lulus: item.hasil.lulus ? "LULUS" : "GAGAL",
                                    is_lulus: item.hasil.lulus,
                                    sesi: item.sesi,
                                    total_waktu: this.convertMenit(item.hasil.total_waktu)
                                }
                            }
                        ))

                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            }
        },
        computed: {
            numberPages() {
                return Math.ceil(this.table.itemSize / this.table.pagination.perPage)
            },
            pageSizes() {
                if (this.riwayat.ujian.length > 100) {
                    return [
                        5, 10, 30, 50, 100
                    ]
                }

                return [
                    5, 10, 30, 50, this.riwayat.ujian.length
                ]
            }
        },
        watch: {
            'table.pagination.current'(newVal) {
                if (!newVal || newVal == 0) {
                    this.table.pagination.current = 1
                }
                if (newVal > this.numberPages) {
                    this.table.pagination.current = this.numberPages
                }
            }
        },
        created() {
            this.initialLoad()

        },
        updated() {
            Vue.set(this.table, 'itemSize', this.$refs.dt.total)

            if (this.$refs.dt.$refs.elPagination) {
                this.$refs.dt.$refs.elPagination.$el.className = 'd-none'
            }
        },
    })
</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('dashboard.components.layout', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/dosp7473/public_html/cpns/dashboard/resources/views/dashboard/riwayat/to.blade.php ENDPATH**/ ?>