<?php $__env->startSection('title'); ?>
Dashboard - Kelas Berbayar
<?php $__env->stopSection(); ?>

<?php $__env->startSection('style'); ?>
<link rel="stylesheet" href="../../assets/css/custom.css" type="text/css">
<link rel="stylesheet" href="../../assets/css/theme-sugar.css" type="text/css">
<link rel="stylesheet" href="../../assets/css/element-ui/index.css" type="text/css">
<link rel="stylesheet" href="../../assets/vendor/vue-select/vue-select.css" type="text/css">

<style>
    .page-item .page-link {
        width: 2rem;
        height: 2rem;

        font-size: 0.75rem;
    }

    .overlay-container {
        position: relative;
    }

    .overlay-image {
        opacity: 1;
        display: block;

        transition: .5s ease;
        backface-visibility: hidden;
    }

    .overlay-middle {
        transition: .5s ease;
        opacity: 0;
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        -ms-transform: translate(-50%, -50%);
        text-align: center;
    }

    .overlay-container:hover .overlay-image {
        opacity: 0.3;
    }

    .overlay-container:hover .overlay-middle {
        opacity: 1;
    }

    .overlay-text {
        background-color: #4CAF50;
        color: white;
        font-size: 16px;
        padding: 16px 32px;
    }
</style>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('search-box'); ?>
<div class="navbar-search navbar-search-light form-inline mr-sm-3" id="navbar-search-main">
    <div class="form-group mb-0" :class="{'focused':table.filters[0].value||table.filters[0].focus}">
        <div class="input-group input-group-alternative input-group-merge">
            <div class="input-group-prepend">
                <span class="input-group-text"><i class="fas fa-search"></i></span>
            </div>
            <input @blur.self="table.filters[0].focus = false" @click="table.filters[0].focus=true" v-model.trim="table.filters[0].value" class="form-control" placeholder="Cari" type="text">

            <div v-if="table.filters[0].value" class="input-group-append mr-2 d-none d-md-flex" @click="table.filters[0].value =  ''">
                <button class="input-group-text"><i class="fas fa-backspace"></i></button>
            </div>

            <div class="input-group-append d-md-none d-flex">
                <button v-if="table.filters[0].value" @click="table.filters[0].value =  ''" class="input-group-text pr-0 pl-2"><i class="fas fa-backspace"></i></button>

                <button data-action="search-close" class="mr-2 input-group-text"><i class="fas fa-times"></i></button>
            </div>
        </div>
    </div>

</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('mobile-search'); ?>
<?php echo $__env->make('dashboard.components.mobile-search', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('page-title'); ?>
<h6 class="h2 text-white d-inline-block mb-0">
    Kelas Berbayar
</h6>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('breadcrumb'); ?>
<li class="breadcrumb-item text-white">
    <i class="fas fa-users"></i>
</li>
<li class="breadcrumb-item text-white">Kelas Berbayar</li>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('action-bar'); ?>

<div class="mt-3 d-sm-none"></div>

<div v-if="isLoaded && !isFailed" class="d-flex justify-content-end d-none" :class="{'d-block':isLoaded && !isFailed}">

    <button @click="showModal('tambah', {})" class="m-1 btn btn-sm btn-neutral">Tambah</button>

</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('content'); ?>
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed" :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="text-primary">List Kelas Berbayar</h3>
                    </div>
                    <div class="card-body">
                        <data-tables ref="dt" style="width: 100%" :page-size.sync="table.pagination.perPage" :current-page.sync="table.pagination.current" @current-page-change="handleCurrentPageChange" :filters="table.filters" :table-props="table.props" :data="kelas_berbayars" :pagination-props="table.pagination">

                            <el-table-column label="Nama" min-width="200" prop="nama" sortable="true">
                                <template slot-scope="scope">
                                    <span class="h4">
                                        {{ scope . row . nama . toUpperCase() }}
                                    </span>
                                </template>
                            </el-table-column>

                            <el-table-column label="Harga" min-width="100" prop="harga" sortable="true" align="center">
                                <template slot-scope="scope">
                                    <div class="d-flex flex-column">
                                        <span class="h3 text-primary">
                                            Rp {{ scope . row . harga.toLocaleString() }},-
                                        </span>
                                        <span class="h4 text-danger">
                                            <del v-if="scope . row . harga_awal>0">
                                                Rp {{ scope . row . harga_awal.toLocaleString() }},-
                                            </del>
                                        </span>
                                    </div>
                                </template>
                            </el-table-column>

                            <el-table-column label="Kuota" min-width="100" prop="quota" sortable="true" align="center">
                                <template slot-scope="scope">

                                    <div class="d-flex flex-column h2" v-if="scope.row.quota>0">
                                        <span class="badge badge-pill badge-primary">
                                            <span>
                                                {{ scope . row . quota }}
                                            </span>
                                        </span>
                                    </div>

                                    <div class="d-flex flex-column h2" v-else>
                                        <span class="badge badge-pill badge-secondary">
                                            <span>
                                                No Limit
                                            </span>
                                        </span>
                                    </div>
                                </template>
                            </el-table-column>

                            <el-table-column label="Mulai" min-width="100" prop="start" sortable="true" align="center">
                                <template slot-scope="scope">
                                    <div class="d-flex flex-column h2" v-if="scope . row . start">
                                        <span class="badge badge-pill badge-primary">
                                            <i class="fas fa-calendar-check">
                                            </i>
                                            <span>
                                                {{ new Date(scope . row . start*1000   ).toLocaleDateString('id-ID')}}
                                            </span>
                                        </span>

                                        <span class="mt-1 badge badge-pill badge-primary">
                                            <i class="fas fa-clock">
                                            </i>
                                            <span>
                                                {{ new Date(scope . row . start*1000).toLocaleTimeString('id-ID')}}
                                            </span>
                                        </span>
                                    </div>

                                    <div class="d-flex flex-column h2" v-else>
                                        <span class="badge badge-pill badge-secondary">
                                            <span>
                                                No Limit
                                            </span>
                                        </span>
                                    </div>
                                </template>
                            </el-table-column>

                            <el-table-column label="Berakhir" min-width="100" prop="end" sortable="true" align="center">
                                <template slot-scope="scope">
                                    <div class="d-flex flex-column h2" v-if="scope . row . end">
                                        <span class="badge badge-pill badge-primary">
                                            <i class="fas fa-calendar-check">
                                            </i>
                                            <span>
                                                {{ new Date(scope . row . end*1000 ).toLocaleDateString('id-ID')}}
                                            </span>
                                        </span>

                                        <span class="mt-1 badge badge-pill badge-primary">
                                            <i class="fas fa-clock">
                                            </i>
                                            <span>
                                                {{ new Date(scope . row . end*1000).toLocaleTimeString('id-ID')}}
                                            </span>
                                        </span>
                                    </div>

                                    <div class="d-flex flex-column h2" v-else>
                                        <span class="badge badge-pill badge-secondary">
                                            <span>
                                                No Limit
                                            </span>
                                        </span>
                                    </div>
                                </template>
                            </el-table-column>

                            <el-table-column label="Tampilkan" min-width="100" prop="show" sortable="true" align="center">
                                <template slot-scope="scope">
                                    <label class="custom-toggle">
                                        <input @click="toggleShow(scope.row)" type="checkbox" :checked="scope . row . show">
                                        <span class="custom-toggle-slider rounded-circle" data-label-off="No" data-label-on="Yes"></span>
                                    </label>
                                </template>
                            </el-table-column>

                            <el-table-column label="Actions" min-width="80" align="center">
                                <template slot-scope="scope">
                                    <el-tooltip class="item" effect="dark" content="Hapus" placement="top">
                                        <button @click="confirmDelete(scope.row)" type="button" class="mr-0 mt-1 btn btn-outline-danger btn-sm btn-icon-only">
                                            <span class="btn-inner--icon"><i class="fas fa-trash"></i></span>
                                        </button>
                                    </el-tooltip>

                                    <el-tooltip class="item" effect="dark" content="Edit" placement="top">
                                        <button @click="editKelasBerbayar(scope.row)" type="button" class="mr-0 mt-1 btn btn-outline-primary btn-sm btn-icon-only">
                                            <span class="btn-inner--icon"><i class="fas fa-pencil-alt"></i></span>
                                        </button>
                                    </el-tooltip>

                                    <el-tooltip class="item" effect="dark" content="Harga khusus per-kelas" placement="top">
                                        <span>
                                            <button class="mr-0 mt-1 btn btn-outline-default btn-sm btn-icon-only" @click="showModal('harga_khusus',{'id_kelas_berbayar':scope.row.id})">
                                                <span class="btn-inner--icon">
                                                    <i class="fas fa-dollar-sign"></i>
                                                </span>
                                            </button>
                                        </span>
                                    </el-tooltip>

                                    <el-tooltip class="item" effect="dark" content="Data Pembayaran" placement="top">
                                        <span>
                                            <a class="mr-0 mt-1 btn btn-outline-warning btn-sm btn-icon-only" :href="'<?php echo e(url('/kelas-berbayar/riwayat-pembayaran?kelas_berbayar_id=')); ?>'+scope.row.id" role="button">
                                                <span class="btn-inner--icon">
                                                    <i class="fas fa-money-check-alt"></i>
                                                </span>
                                            </a>
                                        </span>
                                    </el-tooltip>

                                </template>
                            </el-table-column>

                        </data-tables>
                    </div>

                    <div class="card-footer d-flex  justify-content-around align-items-end pt-2">

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="perpage">Item/Halaman</label>

                            <select id="perpage" v-model="table.pagination.perPage" class="form-control form-control-sm" id="inlineFormCustomSelect">
                                <option v-for="item in pageSizes.length" :key="item" :value="pageSizes[item-1]">
                                    {{ pageSizes[item - 1] + '/page' }}</option>
                            </select>
                        </div>

                        <div class="col-md-8 col-sm-12 d-flex flex-column justify-content-center text-center">
                            <h5>Jumlah data: {{ table.itemSize }}</h5>
                            <paginate :value="table.pagination.current" :page-count="numberPages" :page-range="3" :click-handler="clickCallback" :prev-text="''" :next-text="''" :container-class="'pagination justify-content-center mb-0'" :page-class="'page-item'" :page-link-class="'page-link btn-sm'" :prev-class="'page-item'" :prev-link-class="'fas fa-angle-left page-link'" :next-class="'page-item'" :next-link-class="'fas fa-angle-right page-link'" :hide-prev-next="false" :break-view-text="''" :break-view-link-class="'fas fa-ellipsis-h'">
                            </paginate>
                        </div>

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="to-page">Ke Halaman</label>
                            <input type="number" min="1" max="numberPage" v-model.number="table.pagination.current" id="to-page" class="form-control form-control-sm">
                        </div>

                    </div>
                </div>
            </div>

        </div>

        <confirm-delete v-if="form.delete.confirm" :show-modal="form.delete.confirm" :is-deleting="form.delete.isDeleting" @onclose="closeConfirmDelete" @onconfirm="hapusKelasBerbayar">
        </confirm-delete>

        <div v-if="form.tambah.show" class="d-none" :class="{'d-block':form.tambah.show}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div v-if="!form.isSubmitting" class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle">
                                    {{(!form.isEditing)?'Tambah':'Edit'}}

                                </span>
                            </h5>
                            <button type="button" class="close" @click="closeModalTambah">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0" style="max-height: 30rem; overflow-y: auto;">
                            <div v-if="form.isSubmitting">
                                <div class="spinner">
                                    <div class="rect1 bg-primary"></div>
                                    <div class="rect2 bg-primary"></div>
                                    <div class="rect3 bg-primary"></div>
                                    <div class="rect4 bg-primary"></div>
                                    <div class="rect5 bg-primary"></div>
                                </div>
                                <h3 class="mt-4 mb-5 text-primary text-center">
                                    Sedang menyimpan data..
                                </h3>
                            </div>
                            <div v-if="!form.isSubmitting">

                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="form-group">
                                            <div class="form-group">
                                                <label for="nama">Nama</label>
                                                <input id="nama" v-model.trim="form.data.nama" class="form-control" placeholder="Nama kelas berbayar" type="text" required>
                                            </div>
                                        </div>
                                    </div>

                                </div>

                                <div class="row form-group">
                                    <div class="col-md-6">
                                        <label for="harga">Harga</label>
                                        <input type="number" step="1000" min="10000" minlength="5" id="harga" v-model.number="form.data.harga" class="form-control" placeholder="Harga kelas" required>

                                    </div>

                                    <div class="col-md-6">
                                        <label for="harga_awal">Harga Awal</label>
                                        <input type="number" step="1000" min="10000" minlength="5" id="harga_awal" v-model.number="form.data.harga_awal" class="form-control" placeholder="Harga Awal (sebelum diskon)">

                                    </div>

                                    <small class="form-text text-muted mx-3 mt-2">
                                        <b>Harga awal</b> adalah harga sebelum diskon. Bisa dikosongkan.
                                    </small>
                                </div>

                                <div class="row form-group">
                                    <div class="col-md-6">

                                        <label for="pilih-kelas">Kelas</label>
                                        <div>
                                            <el-select size="large" class="w-100" id="pilih-kelas" v-model="form.data.kelas_id" clearable filterable placeholder="Pilih Kelas">
                                                <el-option v-for="item in form.kelas" :key="item.id" :label="item.nama" :value="item.id">
                                                    <span class="text-capitalize" style="float: left">{{ item.nama }}</span>
                                                </el-option>
                                            </el-select>
                                        </div>

                                    </div>

                                    <div class="col-md-3">
                                        <label for="show">Tampilkan</label>
                                        <div>
                                            <label class="custom-toggle">
                                                <input id="show" type="checkbox" v-model="form.data.show">
                                                <span class="custom-toggle-slider rounded-circle" data-label-off="No" data-label-on="Yes"></span>
                                            </label>
                                        </div>
                                    </div>

                                    <div class="col-md-3">
                                        <label for="quota">Kuota</label>
                                        <div>
                                            <input type="number" minlength="2" id="quota" v-model.number="form.data.quota" class="form-control" placeholder="Tidak wajib">
                                        </div>

                                    </div>

                                    <small class="form-text text-muted mx-3 mt-2">
                                        <b>Kuota Pendaftaran</b> tidak wajib diisi.
                                    </small>

                                </div>

                                <div class="row form-group">
                                    <div class="col-md-12">

                                        <label class="form-control-label" for="fitur">Fitur Utama</label>
                                        <textarea v-model="form.data.fitur" class="form-control" id="fitur" rows="2" required></textarea>


                                    </div>
                                    <small class="form-text text-muted mx-3 mt-2">
                                        Masukkan minimal 3 fitur utama. Setiap fitur dipisahkan dengan tanda ;
                                        (titik koma)
                                    </small>
                                </div>

                                <div class="row form-group">
                                    <div class="col-md-6">
                                        <label for="nama-cp">Nama CP</label>
                                        <div>
                                            <input type="text" id="nama-cp" v-model.number="form.data.nama_cp" class="form-control" placeholder="Nama CP" required>
                                        </div>
                                    </div>

                                    <div class="col-md-6">
                                        <label for="nomor-cp">Nomor CP</label>
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <div class="input-group-text">+62</div>
                                            </div>
                                            <input type="number" minlength="8" maxlength="14" id="nomor-cp" v-model.number="form.data.nomor_cp" class="form-control" placeholder="Nomor WhatsApp" required>
                                        </div>
                                    </div>
                                    <small class="form-text text-muted mx-3 mt-2">
                                        Masukkan nomor WA yang aktif <b>tanpa awalan 0.</b> Contoh:
                                        <b>0895123456</b> menjadi <b>895123456</b>
                                    </small>
                                </div>

                                <div class="row form-group">
                                    <div class="col-md-6">
                                        <label for="mulai">Mulai</label>
                                        <div>
                                            <el-date-picker class="w-100" id="mulai" v-model="form.data.start" type="datetime" value-format="timestamp" placeholder="Batas mulai">
                                            </el-date-picker>
                                        </div>
                                    </div>

                                    <div class="col-md-6">
                                        <label for="berakhir">Berakhir</label>
                                        <div>
                                            <el-date-picker class="w-100" id="berakhir" v-model="form.data.end" type="datetime" value-format="timestamp" placeholder="Batas terakhir">
                                            </el-date-picker>
                                        </div>

                                    </div>
                                    <small class="form-text text-muted mx-3 mt-2">
                                        <b>Mulai</b> adalah tanggal/ waktu pendaftaran dibuka.
                                        <br>
                                        <b>Berakhir</b> adalah batas tanggal/ waktu pendaftaran ditutup.
                                    </small>
                                </div>

                                


                            </div>
                        </div>
                        <div v-if="!form.isSubmitting" class="modal-footer p-3">
                            <button @click="handleReset(form.isEditing)" class="btn btn-secondary">Reset</button>

                            <button @click="handleSubmit(form.isEditing)" class="btn btn-primary" :disabled="!cekFormTambah">
                                {{(form.isEditing)?'Update':'Tambah'}}
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div v-if="form.harga_khusus.show" class="d-none" :class="{'d-block':form.harga_khusus.show}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
                    <div class="modal-content">
                        <div v-if="!form.isSubmitting" class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle">
                                    Harga Khusus
                                </span>
                            </h5>
                            <button type="button" class="close" @click="closeModalHargaKhusus">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0" style="max-height: 30rem; overflow-y: auto;">
                            <div v-if="form.isSubmitting">
                                <div class="spinner">
                                    <div class="rect1 bg-primary"></div>
                                    <div class="rect2 bg-primary"></div>
                                    <div class="rect3 bg-primary"></div>
                                    <div class="rect4 bg-primary"></div>
                                    <div class="rect5 bg-primary"></div>
                                </div>
                                <h3 class="mt-4 mb-5 text-primary text-center">
                                    Sedang menyimpan data..
                                </h3>
                            </div>
                            <div v-if="!form.isSubmitting">
                                <div>
                                    <div class="row">
                                        <div class="col-md-5 form-group">

                                            <label for="pilih-kelas">Kelas</label>
                                            <div>
                                                <el-select size="large" class="w-100" id="pilih-kelas" v-model="form.harga_khusus.kelas" clearable filterable placeholder="Pilih Kelas">
                                                    <el-option v-for="item in form.kelas" :key="item.id" :label="item.nama" :value="item.id">
                                                        <span class="text-capitalize" style="float: left">{{ item.nama }}</span>
                                                    </el-option>
                                                </el-select>
                                            </div>
                                        </div>

                                        <div class="col-md-5 form-group">
                                            <label for="harga">Harga</label>
                                            <input type="number" step="1000" min="10000" minlength="5" id="harga" v-model.number="form.harga_khusus.harga" class="form-control" placeholder="Harga kelas" required>

                                        </div>

                                        <div class="col-md-2 my-auto">
                                            <button class="btn btn-outline-primary btn-block" @click="insertHargaKhusus" :disabled="!cekFormHargaKhusus">Tambah</button>

                                        </div>
                                    </div>
                                </div>
                                <data-tables ref="harga_khusus" style="width: 100%" :data="harga_khusus">

                                    <el-table-column label="Kelas" min-width="200" prop="nama_kelas" sortable="true">
                                        <template slot-scope="scope">
                                            <span class="h4">
                                                {{ scope . row . nama_kelas . toUpperCase() }}
                                            </span>
                                        </template>
                                    </el-table-column>

                                    <el-table-column label="Harga" min-width="100" prop="harga" sortable="true">
                                        <template slot-scope="scope">
                                            Rp {{ scope . row . harga.toLocaleString() }},-
                                        </template>
                                    </el-table-column>

                                    <el-table-column label="Actions" min-width="80" align="center">
                                        <template slot-scope="scope">
                                            <el-tooltip class="item" effect="dark" content="Hapus" placement="top">
                                                <button @click="hapusHargaKhusus(scope.row)" type="button" class="mr-0 mt-1 btn btn-outline-danger btn-sm btn-icon-only">
                                                    <span class="btn-inner--icon"><i class="fas fa-trash"></i></span>
                                                </button>
                                            </el-tooltip>

                                            <!-- <el-tooltip class="item" effect="dark" content="Edit" placement="top">
                                                <button @click="editKelasBerbayar(scope.row)" type="button" class="mr-0 mt-1 btn btn-outline-primary btn-sm btn-icon-only">
                                                    <span class="btn-inner--icon"><i class="fas fa-pencil-alt"></i></span>
                                                </button>
                                            </el-tooltip> -->

                                        </template>
                                    </el-table-column>

                                </data-tables>
                            </div>
                        </div>
                        <div v-if="!form.isSubmitting" class="modal-footer p-3">
                            <!-- <button @click="handleReset(form.isEditing)" class="btn btn-secondary">Reset</button> -->

                            <!-- <button @click="insertHargaKhusus" class="btn btn-primary" :disabled="!cekFormHargaKhusus">
                                Tambah
                            </button> -->
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('script'); ?>
<script src="<?php echo e(asset('assets/js/element-ui/index.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/locales/en.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/data-tables.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-paginate.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-toast-notification.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue/confirm-delete.js')); ?>"></script>

<script>
    let base = "<?php echo e(url('/api')); ?>"
    let kelas_url = base + "/kelas"
    let kelas_berbayar_url = base + "/kelas-berbayar"

    ELEMENT.locale(ELEMENT.lang.en)
    Vue.use(VueToast);
    Vue.use(DataTables.DataTables)

    Vue.component('paginate', VuejsPaginate)

    var app = new Vue({
        el: '#panel',
        data: {
            table: {
                itemSize: 0,
                filters: [{
                    prop: ['nama', 'harga_awal', 'harga', 'start', 'end', 'quota', 'show'],
                    value: '',
                    focus: false
                }],
                pagination: {
                    pageSizes: [10, 30, 50],
                    current: 1,
                    perPage: 10
                }
            },
            form: {
                data: {
                    nama: '',
                    start: '',
                    end: '',
                    nama_cp: '',
                    nomor_cp: '',
                    harga: 0,
                    harga_awal: 0,
                    quota: 0,
                    show: true,
                    // link_telegram: '',
                    fitur: "Fitur 1;Fitur 2;Fitur 3",
                    kelas_id: null,
                },
                kelas: [],
                tambah: {
                    show: false
                },
                harga_khusus: {
                    id_kelas_berbayar: null,
                    show: false,
                    harga: 0,
                    kelas: '',
                    data: [],
                },
                isSubmitting: false,
                isEditing: false,
                update: {
                    show: false,
                    index: '',
                    old: {}
                },
                delete: {
                    confirm: false,
                    isDeleting: false,
                    data: {}
                }
            },
            isFailed: false,
            isLoaded: false,
            kelas_berbayars: [],
            tryouts: [],
            harga_khusus: []
        },
        methods: {
            clickCallback(page) {
                this.table.pagination.current = page
            },
            handleCurrentPageChange(page) {
                this.table.pagination.current = page
            },
            showModal(index, {
                id_kelas_berbayar
            }) {
                this.getKelas()
                if (index === "harga_khusus") {
                    this.form.harga_khusus.id_kelas_berbayar = id_kelas_berbayar
                    this.getHargaKhusus(id_kelas_berbayar)
                }
                this.form[index].show = true
            },
            closeModalTambah() {
                this.resetFormTambah()
                this.form.isSubmitting = false
                this.form.isEditing = false
                this.form.isDeleting = false
                this.form.tambah.show = false
            },
            closeModalHargaKhusus() {
                this.resetFormHargaKhusus()
                this.harga_khusus = []
                this.form.isSubmitting = false
            },
            handleReset(isEditing) {
                if (isEditing) {
                    this.resetFormUpdate()
                } else {
                    this.resetFormTambah()
                }
            },
            handleSubmit(isEditing) {
                if (!isEditing) {
                    this.insertKelasBerbayar()
                } else {
                    this.updateKelasBerbayar()
                }
            },
            resetFormTambah() {
                const data = {
                    nama: '',
                    start: '',
                    end: '',
                    harga: 0,
                    harga_awal: 0,
                    quota: 0,
                    show: true,
                    // link_telegram: '',
                    fitur: "Fitur 1;Fitur 2;Fitur 3",
                    kelas_id: null,
                }

                Vue.set(this.form, 'data', data)
                this.form.isSubmitting = false
            },
            resetFormHargaKhusus() {
                const data = {
                    show: false,
                    harga: 0,
                    kelas: '',
                    data: [],
                }

                Vue.set(this.form, 'harga_khusus', data)
                this.form.isSubmitting = false
            },
            resetFormUpdate() {
                const old = this.form.update.old

                const data = {
                    nama: old.nama,
                    start: old.start,
                    end: old.end,
                    harga: old.harga,
                    harga_awal: old.harga_awal,
                    quota: old.quota,
                    show: old.show,
                    // link_telegram: old.link_telegram,
                    fitur: old.fitur,
                    kelas_id: old.kelas_id,
                }

                Vue.set(this.form, 'data', data)
                this.form.isSubmitting = false
            },
            showToast(msg, type) {
                Vue.$toast.open({
                    message: msg,
                    type: type,
                    // all of other options may go here
                });
            },
            async insertKelasBerbayar() {
                this.form.isSubmitting = true
                let form = this.form.data

                await axios
                    .post(kelas_berbayar_url, form)
                    .then((response) => {

                        this.kelas_berbayars.push(response.data.data)

                        this.showToast(
                            "Berhasil disimpan.", 'info'
                        )
                        this.resetFormTambah()

                    }, (error) => {
                        this.showToast('Gagal disimpan.', 'error')
                    })

            },
            async insertHargaKhusus() {
                this.form.isSubmitting = true
                const bayar = this.form.harga_khusus
                await axios
                    .post(kelas_berbayar_url + "/harga-khusus", {
                        kelas_berbayar_id: bayar.id_kelas_berbayar,
                        kelas_id: bayar.kelas,
                        harga: bayar.harga
                    })
                    .then((response) => {

                        const harga = {
                            id: response.data.data.id,
                            nama_kelas: response.data.data.kelas.nama,
                            harga: response.data.data.harga,
                            kelas_id: response.data.data.kelas.id,
                        }

                        this.harga_khusus.push(harga)

                        this.showToast(
                            "Berhasil disimpan.", 'info'
                        )

                        this.form.isSubmitting = false

                        // this.resetFormTambah()

                    }, (error) => {
                        this.showToast('Gagal disimpan.', 'error')
                    })

            },
            editKelasBerbayar(row) {
                this.form.isEditing = true
                const update = this.form.update
                let index = this.kelas_berbayars.indexOf(row)

                this.getKelas()

                update.index = index
                Vue.set(update, 'old', JSON.parse(JSON.stringify(this.kelas_berbayars[index])))
                Vue.set(this.form, 'data', JSON.parse(JSON.stringify(this.kelas_berbayars[index])))
                Vue.set(this.form.data, 'start', this.kelas_berbayars[index].start * 1000)
                Vue.set(this.form.data, 'end', this.kelas_berbayars[index].end * 1000)
                Vue.set(update.old, 'start', this.kelas_berbayars[index].start * 1000)
                Vue.set(update.old, 'end', this.kelas_berbayars[index].end * 1000)


                this.form.tambah.show = true
            },
            async updateKelasBerbayar() {
                this.form.isSubmitting = true
                let form = this.form.data
                const id_to = this.form.update.old.id
                let id = this.kelas_berbayars.findIndex(function(to) {
                    return to.id == id_to
                })

                await axios
                    .put(kelas_berbayar_url, form)
                    .then((response) => {

                        Vue.set(this.kelas_berbayars, id, response.data.data)

                        this.showToast(
                            `Berhasil update`, 'info'
                        )

                        this.form.isSubmitting = false
                        this.closeModalTambah()

                    }, (error) => {
                        this.showToast('Gagal update data', 'error')
                        this.form.isSubmitting = false
                        this.form.update.show = false
                    })
            },
            async toggleShow(row) {
                let form = this.form.data
                const id_to = this.form.update.old.id
                let id = this.kelas_berbayars.findIndex(function(to) {
                    return to.id == id_to
                })

                let data = {
                    id: row.id,
                    show: !row.show
                }

                await axios
                    .put(kelas_berbayar_url, data)
                    .then((response) => {

                        Vue.set(this.kelas_berbayars, id, response.data.data)

                        this.showToast(
                            `Berhasil update`, 'info'
                        )

                        this.form.isSubmitting = false

                    }, (error) => {
                        this.showToast('Gagal update data', 'error')
                        this.form.isSubmitting = false
                        this.form.update.show = false
                    })
            },
            cancelUpdate() {
                this.resetFormTambah()
                this.showToast('Batal edit data tryouts', 'default')

            },
            confirmDelete(row) {
                this.form.delete.data = row
                this.form.delete.confirm = true
            },
            closeConfirmDelete() {
                this.form.delete.data = {}
                this.form.delete.confirm = false
                this.form.delete.isDeleting = false
            },
            async hapusKelasBerbayar() {
                this.form.delete.isDeleting = true

                let item = this.form.delete.data
                let id = this.kelas_berbayars.indexOf(item)

                await axios
                    .delete(kelas_berbayar_url, {
                        data: {
                            id: item.id
                        }
                    })
                    .then((response) => {
                        this.kelas_berbayars.splice(id, 1)

                        this.showToast(
                            `Berhasil menghapus Data`, 'info'
                        )

                        this.closeConfirmDelete()

                    }, (error) => {
                        this.showToast('Gagal menghapus data', 'error')

                        this.closeConfirmDelete()
                    })

            },
            async hapusHargaKhusus(item) {
                this.form.delete.isDeleting = true

                let id = this.harga_khusus.indexOf(item)

                await axios
                    .delete(kelas_berbayar_url + "/harga-khusus", {
                        data: {
                            id: item.id
                        }
                    })
                    .then((response) => {
                        this.harga_khusus.splice(id, 1)

                        this.showToast(
                            `Berhasil menghapus Data`, 'info'
                        )

                    }, (error) => {
                        this.showToast('Gagal menghapus data', 'error')
                    })

            },
            async getKelas() {
                await axios
                    .get(kelas_url)
                    .then((response) => {
                        this.form.kelas = response.data.data
                    })
            },
            async getHargaKhusus(id) {
                await axios
                    .get(kelas_berbayar_url + "/harga-khusus/" + id)
                    .then((response) => {
                        const harga = response.data.data.map((e) => {
                            return {
                                id: e.id,
                                nama_kelas: e.kelas.nama,
                                harga: e.harga,
                                kelas_id: e.kelas.id,

                            }
                        })
                        Vue.set(this, "harga_khusus", harga)
                    })
            },
            async initialLoad() {
                await axios
                    .get(kelas_berbayar_url)
                    .then((response) => {
                        Vue.set(this, "kelas_berbayars", response.data.data)
                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            }
        },
        computed: {
            getSisaKelas() {

                return null
            },
            cekFormTambah() {
                let tambah = this.form.data

                return (tambah.nama && tambah.harga && tambah.kelas_id && tambah.fitur && tambah.nama_cp && tambah.nomor_cp)
            },
            cekFormHargaKhusus() {
                let tambah = this.form.harga_khusus

                return (tambah.harga && tambah.kelas)
            },
            numberPages() {
                return Math.ceil(this.table.itemSize / this.table.pagination.perPage)
            },
            pageSizes() {
                if (this.kelas_berbayars.length > 100) {
                    return [
                        5, 10, 30, 50, 100
                    ]
                }

                return [
                    5, 10, 30, 50, this.kelas_berbayars.length
                ]
            }
        },
        watch: {
            'table.pagination.current'(newVal) {
                if (!newVal || newVal == 0) {
                    this.table.pagination.current = 1
                }
                if (newVal > this.numberPages) {
                    this.table.pagination.current = this.numberPages
                }
            }
        },
        created() {
            this.initialLoad()

        },
        updated() {
            Vue.set(this.table, 'itemSize', this.$refs.dt.total)
            if (this.$refs.dt.$refs.elPagination) {
                this.$refs.dt.$refs.elPagination.$el.className = 'd-none'
            }
        },
    })
</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('dashboard.components.layout', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/dosp7473/public_html/cpns/dashboard/resources/views/dashboard/kelas-berbayar/admin/index.blade.php ENDPATH**/ ?>