

<?php $__env->startSection('title'); ?>
Dashboard - Kelas Berbayar
<?php $__env->stopSection(); ?>

<?php $__env->startSection('style'); ?>
<link rel="stylesheet" href="<?php echo e(asset('assets/css/theme-sugar.css')); ?>" type="text/css">
<link rel="stylesheet" href="<?php echo e(asset('assets/vendor/vue-select/vue-select.css')); ?>" type="text/css">

<?php $__env->stopSection(); ?>

<?php $__env->startSection('search-box'); ?>
<div class="navbar-search navbar-search-light form-inline mr-sm-3" id="navbar-search-main">
    <div class="form-group mb-0" :class="{'focused':search.value||search.focus}">
        <div class="input-group input-group-alternative input-group-merge">
            <div class="input-group-prepend">
                <span class="input-group-text"><i class="fas fa-search"></i></span>
            </div>
            <input @blur.self="search.focus = false" @click="search.focus=true" v-model.trim="search.value"
                class="form-control" placeholder="Cari" type="text">

            <div v-if="search.value" class="input-group-append mr-2 d-none d-md-flex" @click="search.value =  ''">
                <button class="input-group-text"><i class="fas fa-backspace"></i></button>
            </div>

            <div class="input-group-append d-md-none d-flex">
                <button v-if="search.value" @click="search.value =  ''" class="input-group-text pr-0 pl-2"><i
                        class="fas fa-backspace"></i></button>

                <button data-action="search-close" class="mr-2 input-group-text"><i class="fas fa-times"></i></button>
            </div>
        </div>
    </div>
</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('mobile-search'); ?>
<?php echo $__env->make('dashboard.components.mobile-search', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('page-title'); ?>
<h6 class="h2 text-white d-inline-block mb-0">Kelas Berbayar</h6>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('breadcrumb'); ?>
<li class="breadcrumb-item text-white">

    <i class="fas fa-users"></i>

</li>
<li class="breadcrumb-item text-white">Kelas Berbayar</li>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('action-bar'); ?>
<div v-if="isLoaded && !isFailed" class="d-none" :class="{'d-block':isLoaded && !isFailed}">


    

    <!-- <a href="#" class="m-1 btn btn-sm btn-neutral" @click="sort.show=true">Urutkan</a> -->
</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('content'); ?>
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed"
        :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div id="materi-area" class="card mb-0">

            <div class="card-body px-3 pb-0 pt-3">
                <div v-if="!pagePaginated.total" class="row">
                    <div class="col align-self-center">
                        <div v-if="search.value"
                            class="h2 text-danger text-center d-flex flex-column align-items-center m-4 p-4">
                            <span><i class="far fa-sad-tear fa-4x mb-2"></i></span>
                            <p class="display-1 w-900 mb-0"></i> 404 - Not Found</p>

                            <span class="h3 text-default mb-4">Kelas yang Anda cari tidak ditemukan</span>

                            <button @click="search.value=''" class="btn btn-outline-primary">
                                Hapus Pencarian
                            </button>

                        </div>

                        <div v-if="!search.value"
                            class="h2 text-primary text-center d-flex flex-column align-items-center m-4 p-4">
                            <span><i class="fa fa-check-circle fa-4x mb-2"></i></span>
                            <p class="display-3 w-900 mb-0"></i> Tidak ada kelas berbayar baru</p>

                            <span class="h2 text-default mb-4">Anda sudah terdaftar di semua kelas berbayar.</span>
                        </div>
                    </div>
                </div>

                <div v-else class="row">
                    <div class="col-sm-6 col-md-4 mb-3" v-for="(kelas, index) in pagePaginated.data" :key="index">
                        <div class="card card-pricing h-100 border-0 text-center mb-4">
                            <div class="card-header bg-primary">
                                <h3 class="text-uppercase ls-1 text-primary mb-0 text-white">
                                    {{ kelas . nama }}
                                </h3>
                            </div>
                            <div class="card-body">
                                <div>
                                    <div class="display-4 text-gray" v-if="kelas.harga_awal">
                                        <del> Rp {{ Number(kelas.harga_awal).toLocaleString('id-ID') }},-</del>
                                    </div>

                                    <div class="display-3">
                                        Rp {{ Number(kelas.harga).toLocaleString('id-ID') }},-
                                    </div>

                                    <div class="d-flex flex-column flex-wrap" v-if="kelas.end">

                                        <span class="h4 mt-4 text-gray">
                                            Batas Pendaftaran:
                                        </span>
                                        <span class="h3">
                                            {{ (new Date(kelas.end*1000)).toLocaleString('id-ID') }}
                                        </span>

                                    </div>

                                </div>

                                <ul class="list-unstyled my-4">
                                    <li v-for="(e, i) in kelas.fitur.split(';')">
                                        <div class="d-flex align-items-center">
                                            <div>
                                                <div
                                                    class="icon icon-xs icon-shape bg-gradient-primary text-white shadow rounded-circle">
                                                    <i class="fas fa-check"></i>
                                                </div>
                                            </div>
                                            <div>
                                                <span class="pl-2 text-sm">
                                                    {{e}}
                                                </span>
                                            </div>
                                        </div>
                                    </li>

                                </ul>
                            </div>

                            <a :href="`<?php echo e(url('/kelas-berbayar/pembayaran/')); ?>/${kelas.id}`">
                                <div style="cursor: pointer"
                                    class="card-footer bg-primary d-flex flex-wrap justify-content-between align-content-center text-white">
                                    <span>Daftar Sekarang</span>
                                    <span><i class="fas fa-chevron-right"></i></span>
                                </div>

                                
                        </a>

                    </div>
                </div>

            </div>
        </div>

        <div v-if="filteredItems.length > pagination.perPage">
            <div id="pagination" class="card-footer">
                <paginate :value="pagination.current" :page-count="pagination.numPages" :page-range="3"
                    :click-handler="onPageChange" :prev-text="''" :next-text="''"
                    :container-class="'pagination justify-content-center mb-0'" :page-class="'page-item'"
                    :page-link-class="'page-link btn-sm'" :prev-class="'page-item'"
                    :prev-link-class="'fas fa-angle-left page-link'" :next-class="'page-item'"
                    :next-link-class="'fas fa-angle-right page-link'" :hide-prev-next="false" :break-view-text="''"
                    :break-view-link-class="'fas fa-ellipsis-h'">
                </paginate>
            </div>
        </div>

    </div>

    <div :class="{'d-none':!modal.show}">
        <div class="modal fade show modal-active" tabindex="-1" role="dialog">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content">
                    <div class="text-center text-primary modal-body px-3 pt-3 pb-0 d-flex flex-column">
                        <div class="text-center d-flex flex-column">
                            <span>
                                <i class="fas fa-info-circle fa-5x"></i>
                            </span>
                            <span class="h3 text-primary mt-4">
                                Sebelum melanjutkan proses pembayaran pastikan alamat email Anda benar dan valid
                                karena link group akan dikirimkan melalui
                                email.
                                
                            </span>
                        </div>
                    </div>
                    <div class="modal-footer p-3 d-flex justify-content-end">
                        <button @click="closeModal" type="button" class="btn btn-secondary">Batal</button>
                        <a :href="modal.url" class="btn btn-primary">
                            Lanjutkan
                        </a>
                    </div>
                </div>
            </div>
        </div>
    </div>

</div>
</div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('script'); ?>

<script src="<?php echo e(asset('assets/js/vue-toast-notification.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-paginate.js')); ?>"></script>

<script>
    let konten_url = "<?php echo e(url('/api/kelas-berbayar')); ?>"

    Vue.use(VueToast);

    Vue.component('paginate', VuejsPaginate)


    var app = new Vue({
        el: '#panel',
        data: {
            modal: {
                show: false,
                url: '#'
            },
            pagination: {
                current: 1,
                total: 0,
                perPage: 8,
                numPages: 0
            },
            search: {
                value: '',
                focus: false
            },
            isFailed: false,
            isLoaded: false,
            kelas_berbayars: null
        },
        methods: {
            closeModal() {
                this.modal.show = false
                this.modal.url = '#'
            },
            openModal(url) {
                this.modal.show = true
                this.modal.url = url
            },
            onPageChange(page) {
                this.pagination.current = page;
            },
            paginator(items, current_page, per_page_items) {
                let page = current_page || 1,
                    per_page = per_page_items || 10,
                    offset = (page - 1) * per_page,

                    paginatedItems = items.slice(offset).slice(0, per_page_items),
                    total_pages = Math.ceil(items.length / per_page);

                this.pagination.numPages = total_pages
                // this.pagination.data = paginatedItems

                return {
                    total: items.length,
                    data: paginatedItems
                }
            },
            sortMateri(data, properti, order) {
                if (order == 'asc' || order == '') {
                    return data.sort((a, b) => (a[properti] > b[properti]) ? 1 : -1)
                }
                if (order == 'desc') {
                    return data.sort((a, b) => (a[properti] > b[properti]) ? -1 : 1)
                }
            },
            async initialLoad() {
                await axios
                    .get(konten_url)
                    .then((response) => {
                        this.kelas_berbayars = response.data.data

                        this.pagination.total = response.data.data.length
                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            },
            unixToDateTime(epoch) {
                let unix = epoch * 1000
                let dt = new Date(unix)

                return dt.toLocaleString('id-ID', {
                    dateStyle: 'short',
                    timeStyle: 'short'
                })

            }
        },
        computed: {
            filteredItems() {
                let search = this.search.value.toLowerCase().trim()
                let filtered = [...this.kelas_berbayars]

                if (!search) return this.kelas_berbayars

                return filtered.filter(c => c.nama.toLowerCase().indexOf(search) > -1);
            },
            pagePaginated() {
                let paginated = this.paginator(this.filteredItems, this.pagination.current, this.pagination
                    .perPage)

                return paginated
            }
        },
        watch: {
            'pagination.numPages'(newVal) {
                if (this.pagination.current > newVal) {
                    this.pagination.current = newVal
                }
            },
        },
        created() {
            this.initialLoad()
        }
    })
</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('dashboard.components.layout', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/dosp7473/public_html/cpns/dashboard/resources/views/dashboard/kelas-berbayar/user/index.blade.php ENDPATH**/ ?>